//F1_FormatNamenAuflisten_202d.js
// 28.11.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script setzt die Namen der Absatz- und der Zeichenvorlagen 
//in zwei benannte Rahmen. Diese Listen knnen editiert werden (ganze 
//Zeilen entfernen). Dann das Script "F2_FormatAttribute" starten, in den 
//Mens das Sternchen einstellen. Auf "OK" werden nur die Attribute der 
//Formate in der Liste ausgezogen und in ein neues Dokument eingesetzt.

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// den Nullpunkt auf Null/Null setzten
app.documents[0].zeroPoint = [0,0];

// das Zeichenformat auf "Kein" setzen
var noCharStyle = app.documents[0].characterStyles.item(0);
app.documents[0].textDefaults.appliedCharacterStyle = noCharStyle;
// das Absatzformat auf "Einfacher Absatz" setzen
var dfParaStyle = app.documents[0].paragraphStyles.item(1);
app.documents[0].textDefaults.appliedParagraphStyle = dfParaStyle;

// eventuell vorhandene Rahmen entfernen. Sonst wrde ein Laufzeitfehler generiert, 
// weil das "FormatAttribute"-Script nur einen Rahmen jeder Sorte erwartet
try {
	app.documents[0].textFrames.item("ParaStyles").remove();
}
catch (e) {
}

try {
	app.documents[0].textFrames.item("CharStyles").remove();
}
catch (e) {
}

//--- die Liste der Absatzformatnamen aufstellen ---//
var allParaStyles = app.documents[0].paragraphStyles.everyItem().name;

// das erste Element entfernen
allParaStyles.shift();

// die Liste in eine Textkette verwandeln
var paraString = allParaStyles.join("\r");

// einen Textrahmen erzeugen
var paraFrame = app.documents[0].pages[0].textFrames.add();
paraFrame.properties = {geometricBounds:[12, 15, 285, 105.5], fillColor:"Paper", label:"ParaStyles"};

// die vorbereitete Textkette in den Rahmen einsetzen
paraFrame.parentStory.contents = paraString;

//--- die Liste der Zeichenformatnamen aufstellen ---//
var allCharStyles = app.documents[0].characterStyles.everyItem().name;

// das erste Element entfernen
allCharStyles.shift();

// die Liste in eine Textkette verwandeln
var charString = allCharStyles.join("\r");

// einen Textrahmen erzeugen
var charFrame = app.documents[0].pages[0].textFrames.add();
charFrame.properties = {geometricBounds:[12, 109.5, 285, 200], fillColor:"Paper", label:"CharStyles"};

// die vorbereitete Textkette in den Rahmen einsetzen
charFrame.parentStory.contents = charString;