//F3_WerteRunden_203d.js
// 29.12.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script dient zum Runden von Werten mit vielen Nachkommastellen
//auf die Zahl, welche in den Dialogen der Absatz- und Zeichenformate erscheint

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

//--- die Liste der Absatzformatnamen aufstellen ---//
var paraStyles = app.documents[0].paragraphStyles.everyItem().name;
// das erste Element durch ein Sternchen ersetzen
paraStyles[0] = "*";
// zu Beginn ein leeres Element einfgen
paraStyles = [""].concat(paraStyles);
nParaStyles = paraStyles.length;

//--- die Liste der Zeichenformatnamen aufstellen ---//
var charStyles = app.documents[0].characterStyles.everyItem().name;
// das erste Element durch ein Sternchen ersetzen
charStyles[0] = "*";
// zu Beginn ein leeres Element einfgen
charStyles = [""].concat(charStyles);
nCharStyles = charStyles.length;

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// einen Dialog erzeugen
var aDialog = app.dialogs.add({name:"Das Format auswhlen", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Absatzformate:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:paraStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Zeichenformate:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:charStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// den Dialog zeigen
if (aDialog.show() == true) {
	// die Wahl des Anwenders bernehmen
	var paraID = paraName.selectedIndex;
	var charID = charName.selectedIndex;
	// den Dialog aus dem Speicher entfernen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Wahl des Anwenders prfen
if (paraID != 0) {
	if (paraID == 1) {
		try {
			var paraString = app.documents[0].textFrames.item("ParaStyles").parentStory.contents;
			paraStyles = paraString.split("\r");
			paraStyles = ["", "*"].concat(paraStyles);
			nParaStyles = paraStyles.length;
		}
		catch (e) {
		}
		for (var p=2; p<nParaStyles; p++) {
			roundParaVals(p);
		}
	}
	else {
		roundParaVals(paraID);
	}
}
if (charID != 0) {
	if (charID == 1) {
		try {
			var charString = app.documents[0].textFrames.item("CharStyles").parentStory.contents;
			charStyles = charString.split("\r");
			charStyles = ["", "*"].concat(charStyles);
			nCharStyles = charStyles.length;
		}
		catch (e) {
		}
		for (var c=2; c<nCharStyles; c++) {
			roundCharVals(c);
		}
	}
	else {
		roundCharVals(charID);
	}
}

// den Anwender informieren
alert("Fertig.", " ");

//**********************************************************
// die Absatzformat-Werte auf drei Nachkommastellen krzen
//**********************************************************
function roundParaVals(p) {
	try {
		// die Attribute des aktuellen Absatzformates speichern
		var curPara = app.documents[0].paragraphStyles.item(paraStyles[p])
		var curProps = curPara.properties;
		// Schriftgre
		var siz = curProps.pointSize;
		siz = Math.floor((siz*1000) + 0.5) / 1000;
		// Zeilenabstand
		var led = curProps.leading;
		led = Math.floor((led*1000) + 0.5) / 1000;
		// horizontale Skalierung
		var hsc = curProps.horizontalScale;
		hsc = Math.floor((hsc*1000) + 0.5) / 1000;
		// Grundlinienversatz
		var bls = curProps.baselineShift;
		bls = Math.floor((bls*1000) + 0.5) / 1000;
		// Einzug links
		var lin = curProps.leftIndent;
		lin = Math.floor((lin*1000) + 0.5) / 1000;
		// Einzug erste Zeile
		var fln = curProps.firstLineIndent;
		fln = Math.floor((fln*1000) + 0.5) / 1000;
		// Einzug rechts
		var rin = curProps.rightIndent;
		rin = Math.floor((rin*1000) + 0.5) / 1000;
		// Abstand vor
		var spb = curProps.spaceBefore;
		spb = Math.floor((spb*1000) + 0.5) / 1000;
		// Abstand nach
		var spa = curProps.spaceAfter;
		spa = Math.floor((spa*1000) + 0.5) / 1000;
		// Wortabstand
		var mws = curProps.minimumWordSpacing;
		mws = Math.floor(mws + 0.5);
		// Autom. Zeilenabstand
		var ald = curProps.autoLeading;
		ald = Math.floor(ald + 0.5);
		// die gerundeten Werte zuweisen
		curPara.properties = {pointSize:siz, leading:led, horizontalScale:hsc, baselineShift:bls, 
			leftIndent:lin, firstLineIndent:fln, rightIndent:rin, spaceBefore:spb, spaceAfter:spa, 
			minimumWordSpacing:mws, autoLeading:ald};
		
		// Tabulatorpositionen
		var tbl = curProps.tabList;
		var nTabs = tbl.length;
		if (nTabs != 0) {
			for (var i=0; i<nTabs; i++) {
				var curPos = tbl[i].position;
				curPos = Math.floor((curPos*1000) + 0.5) / 1000;
				tbl[i].position = curPos;
			}
			// die gerundeten Werte zuweisen
			curPara.properties = {tabList:tbl};
		}
		
		// Absatzlinie darber
		var rab = curProps.ruleAbove;
		if (rab) {
			var raw = curProps.ruleAboveLineWeight;
			raw = Math.floor((raw*1000) + 0.5) / 1000;
			var rao = curProps.ruleAboveOffset;
			rao = Math.floor((rao*1000) + 0.5) / 1000;
			var rali = curProps.ruleAboveLeftIndent;
			rali = Math.floor((rali*1000) + 0.5) / 1000;
			var rari = curProps.ruleAboveRightIndent;
			rari = Math.floor((rari*1000) + 0.5) / 1000;
			// die gerundeten Werte zuweisen
			curPara.properties = {ruleAboveLineWeight:raw, ruleAboveOffset:rao, ruleAboveLeftIndent:rali, ruleAboveRightIndent:rari};
		}
		// Absatzlinie darunter
		var rbe = curProps.ruleBelow;
		if (rbe) {
			var rbw = curProps.ruleBelowLineWeight;
			rbw = Math.floor((rbw*1000) + 0.5) / 1000;
			var rbo = curProps.ruleBelowOffset;
			rbo = Math.floor((rbo*1000) + 0.5) / 1000;
			var rbli = curProps.ruleBelowLeftIndent;
			rbli = Math.floor((rbli*1000) + 0.5) / 1000;
			var rbri = curProps.ruleBelowRightIndent;
			rbri = Math.floor((rbri*1000) + 0.5) / 1000;
			// die gerundeten Werte zuweisen
			curPara.properties = {ruleBelowLineWeight:rbw, ruleBelowOffset:rbo, ruleBelowLeftIndent:rbli, ruleBelowRightIndent:rbri};
		}
	}
	catch (e) {
	}
}

//***********************************************************
// die Zeichenformat-Werte auf drei Nachkommastellen krzen
//***********************************************************
function roundCharVals(c) {
		// die Attribute des aktuellen Zeichenformates speichern
	var curChar = app.documents[0].characterStyles.item(charStyles[c])
	var curProps = curChar.properties;
	try {
		// Schriftgre
		var siz = curProps.pointSize;
		siz = Math.floor((siz*1000) + 0.5) / 1000;
		// den gerundeten Wert zuweisen
		curChar.pointSize = siz;
	}
	catch (e) {
	}
	try {
		// Zeilenabstand
		var led = curProps.leading;
		led = Math.floor((led*1000) + 0.5) / 1000;
		// den gerundeten Wert zuweisen
		curChar.leading = led;
	}
	catch (e) {
	}
	try {
		// horizontale Skalierung
		var hsc = curProps.horizontalScale;
		hsc = Math.floor((hsc*1000) + 0.5) / 1000;
		// den gerundeten Wert zuweisen
		curChar.horizontalScale = hsc;
	}
	catch (e) {
	}
	try {
		// Grundlinienversatz
		var bls = curProps.baselineShift;
		bls = Math.floor((bls*1000) + 0.5) / 1000;
		// den gerundeten Wert zuweisen
		curChar.baselineShift = bls;
	}
	catch (e) {
	}
}